require 'net/http'
require 'uri'
require 'json'
require 'oauth'

module Net
  class HTTPResponse
    def each_line(rs="\n")
      stream_check
      while line = @socket.readuntil(rs)
        yield line
      end
      self
    end
  end
end

class TwitterUserStream

  def initialize(params={})
    @consumer = OAuth::Consumer.new(
      params[:consumer_token],
      params[:consumer_secret]
    )
    @access = OAuth::Token.new(
      params[:access_token],
      params[:access_secret]
    )
    self
  end

  def each_status(params=nil)
    uri = URI.parse("https://userstream.twitter.com/2/user.json?replies=all")
    http = Net::HTTP.new(uri.host,uri.port)
    http.use_ssl = true
    http.start
    request = Net::HTTP::Get.new(uri.request_uri)
    request.set_form_data(params) if params
    request.oauth!(http,@consumer,@access)
    begin
      http.request(request) do |response|
        response.each_line("\r\n") do |line|
          j = JSON.parse(line) rescue next
          yield j
        end
      end
    ensure http.finish end
  end
end
